# CfnImageRecipe

Creates a new image recipe.

Image recipes define how images are configured, tested, and assessed.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnImageRecipe
Implements: IInspectable, ITaggable, IEnvironmentAware, IImageRecipeRef, IConstruct, IDependable

- CloudFormation: [`AWS::ImageBuilder::ImageRecipe`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-imagebuilder-imagerecipe.html)
- Source: Generated code
- Type last changed: v2.262.0 · 22 Jul 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_imagebuilder as imagebuilder } from 'aws-cdk-lib';
const cfnImageRecipe = new imagebuilder.CfnImageRecipe(this, 'MyCfnImageRecipe', {
  name: 'name',
  parentImage: 'parentImage',
  version: 'version',

  // the properties below are optional
  additionalInstanceConfiguration: {
    systemsManagerAgent: {
      uninstallAfterBuild: false,
    },
    userDataOverride: 'userDataOverride',
  },
  amiTags: {
    amiTagsKey: 'amiTags',
  },
  amiWatermarks: ['amiWatermarks'],
  blockDeviceMappings: [{
    deviceName: 'deviceName',
    ebs: {
      deleteOnTermination: false,
      encrypted: false,
      iops: 123,
      kmsKeyId: 'kmsKeyId',
      snapshotId: 'snapshotId',
      throughput: 123,
      volumeSize: 123,
      volumeType: 'volumeType',
    },
    noDevice: 'noDevice',
    virtualName: 'virtualName',
  }],
  components: [{
    componentArn: 'componentArn',
    parameters: [{
      name: 'name',
      value: ['value'],
    }],
  }],
  description: 'description',
  tags: {
    tagsKey: 'tags',
  },
  workingDirectory: 'workingDirectory',
});
```

## Initializer

```ts
new CfnImageRecipe(scope: Construct, id: string, props: CfnImageRecipeProps)
```

## Construct Props

- `additionalInstanceConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.AdditionalInstanceConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.AdditionalInstanceConfigurationProperty.html) — Before you create a new AMI, Image Builder launches temporary Amazon EC2 instances to build and test your image configuration.

  Instance configuration adds a layer of control over those instances. You can define settings and add scripts to run when an instance is launched from your AMI.

- `amiTags`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: string } — Tags that are applied to the AMI that Image Builder creates during the Build phase prior to image distribution.

- `amiWatermarks`: string[] — The AMI watermark names to attach to the output AMI from this recipe.

  AMI watermarks are lineage markers that automatically propagate to derivative AMIs when the source AMI is copied or distributed.

- `blockDeviceMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.InstanceBlockDeviceMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.InstanceBlockDeviceMappingProperty.html)[] — The block device mappings to apply when creating images from this recipe.

- `components`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.ComponentConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.ComponentConfigurationProperty.html)[] — The components that are included in the image recipe.

  Recipes require a minimum of one build component, and can have a maximum of 20 build and test components in any combination.

- `description`: string — The description of the image recipe.

- `name`: string (required) — The name of the image recipe.

- `parentImage`: string (required) — The base image for customizations specified in the image recipe.

  You can specify the parent image using one of the following options:

  - AMI ID
  - Image Builder image Amazon Resource Name (ARN)
  - AWS Systems Manager (SSM) Parameter Store Parameter, prefixed by `ssm:` , followed by the parameter name or ARN.
  - AWS Marketplace product ID

- `tags`: { [key: string]: string } — The tags of the image recipe.

- `version`: string (required) — The semantic version of the image recipe. This version follows the semantic version syntax.

  > The semantic version has four nodes: <major>.<minor>.<patch>/<build>. You can assign values for the first three, and can filter on all of them.
  >
  > *Assignment:* For the first three nodes you can assign any positive integer value, including zero, with an upper limit of 2^30-1, or 1073741823 for each node. Image Builder automatically assigns the build number to the fourth node.
  >
  > *Patterns:* You can use any numeric pattern that adheres to the assignment requirements for the nodes that you can assign. For example, you might choose a software version pattern, such as 1.0.0, or a date, such as 2021.01.01.

- `workingDirectory`: string — The working directory to be used during build and test workflows.

## Properties

- `additionalInstanceConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.AdditionalInstanceConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.AdditionalInstanceConfigurationProperty.html) — Before you create a new AMI, Image Builder launches temporary Amazon EC2 instances to build and test your image configuration.

- `amiTags`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | { [key: string]: string } — Tags that are applied to the AMI that Image Builder creates during the Build phase prior to image distribution.

- `amiWatermarks`: string[] — The AMI watermark names to attach to the output AMI from this recipe.

- `attrArn`: string — Returns the Amazon Resource Name (ARN) of the image recipe.

  For example, `arn:aws:imagebuilder:us-east-1:123456789012:image-recipe/mybasicrecipe/2019.12.03` .

- `attrLatestVersion`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — The latest version references of the image recipe.

- `attrLatestVersionArn`: string — The latest version Amazon Resource Name (ARN) of the Image Builder resource.

- `attrLatestVersionMajor`: string — The latest version Amazon Resource Name (ARN) with the same `major` version of the Image Builder resource.

- `attrLatestVersionMinor`: string — The latest version Amazon Resource Name (ARN) with the same `minor` version of the Image Builder resource.

- `attrLatestVersionPatch`: string — The latest version Amazon Resource Name (ARN) with the same `patch` version of the Image Builder resource.

- `attrName`: string — The name of the image recipe.

- `blockDeviceMappings`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.InstanceBlockDeviceMappingProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.InstanceBlockDeviceMappingProperty.html)[] — The block device mappings to apply when creating images from this recipe.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `components`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnImageRecipe.ComponentConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_imagebuilder.CfnImageRecipe.ComponentConfigurationProperty.html)[] — The components that are included in the image recipe.

- `creationStack`: string[]

- `description`: string — The description of the image recipe.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `imageRecipeRef`: [ImageRecipeReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_imagebuilder.ImageRecipeReference.html) — A reference to a ImageRecipe resource.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `name`: string — The name of the image recipe.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `parentImage`: string — The base image for customizations specified in the image recipe.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: { [key: string]: string } — The tags of the image recipe.

- `version`: string — The semantic version of the image recipe.

  This version follows the semantic version syntax.

- `workingDirectory`: string — The working directory to be used during build and test workflows.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForImageRecipe(resource: IImageRecipeRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnImageRecipe(x: any): boolean` (static) — Checks whether the given object is a CfnImageRecipe.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
